---
title: mask-repeat
slug: Web/CSS/mask-repeat
tags:
  - CSS
  - CSS Masking
  - CSS Property
  - Experimental
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>mask-repeat</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets how mask images are repeated. A mask image can be repeated along the horizontal axis, the vertical axis, both axes, or not repeated at all.</p>

<pre class="brush: css no-line-numbers notranslate">/* One-value syntax */
mask-repeat: repeat-x;
mask-repeat: repeat-y;
mask-repeat: repeat;
mask-repeat: space;
mask-repeat: round;
mask-repeat: no-repeat;

/* Two-value syntax: horizontal | vertical */
mask-repeat: repeat space;
mask-repeat: repeat repeat;
mask-repeat: round space;
mask-repeat: no-repeat round;

/* Multiple values */
mask-repeat: space round, no-repeat;
mask-repeat: round repeat, space, repeat-x;

/* Global values */
mask-repeat: inherit;
mask-repeat: initial;
mask-repeat: unset;
</pre>

<p>By default, the repeated images are clipped to the size of the element, but they can be scaled to fit (using <code>round</code>) or evenly distributed from end to end (using <code>space</code>).</p>

<h2 id="Syntax">Syntax</h2>

<p>One or more <code>&lt;repeat-style&gt;</code> values, separated by commas.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>&lt;repeat-style&gt;</code></dt>
 <dd>The one-value syntax is a shorthand for the full two-value syntax:</dd>
 <dd>
 <table class="standard-table">
  <tbody>
   <tr>
    <td><strong>Single value</strong></td>
    <td><strong>Two-value equivalent</strong></td>
   </tr>
   <tr>
    <td><code>repeat-x</code></td>
    <td><code>repeat no-repeat</code></td>
   </tr>
   <tr>
    <td><code>repeat-y</code></td>
    <td><code>no-repeat repeat</code></td>
   </tr>
   <tr>
    <td><code>repeat</code></td>
    <td><code>repeat repeat</code></td>
   </tr>
   <tr>
    <td><code>space</code></td>
    <td><code>space space</code></td>
   </tr>
   <tr>
    <td><code>round</code></td>
    <td><code>round round</code></td>
   </tr>
   <tr>
    <td><code>no-repeat</code></td>
    <td><code>no-repeat no-repeat</code></td>
   </tr>
  </tbody>
 </table>
 In the two-value syntax, the first value represents the horizontal repetition behavior and the second value represents the vertical behavior. Here is an explanation of how each option works for either direction:</dd>
 <dd>
 <table class="standard-table">
  <tbody>
   <tr>
    <td><code>repeat</code></td>
    <td>The image is repeated as much as needed to cover the whole mask painting area. The last image will be clipped if it doesn't fit.</td>
   </tr>
   <tr>
    <td><code>space</code></td>
    <td>The image is repeated as much as possible without clipping. The first and last images are pinned to either side of the element, and whitespace is distributed evenly between the images. The {{cssxref("mask-position")}} property is ignored unless only one image can be displayed without clipping. The only case where clipping happens using <code>space</code> is when there isn't enough room to display one image.</td>
   </tr>
   <tr>
    <td><code>round</code></td>
    <td>As the allowed space increases in size, the repeated images will stretch (leaving no gaps) until there is room for another one to be added. When the next image is added, all of the current ones compress to allow room. Example: An image with an original width of 260px, repeated three times, might stretch until each repetition is 300px wide, and then another image will be added. They will then compress to 225px.</td>
   </tr>
   <tr>
    <td><code>no-repeat</code></td>
    <td>The image is not repeated (and hence the mask painting area will not necessarily be entirely covered). The position of the non-repeated mask image is defined by the {{cssxref("mask-position")}} CSS property.</td>
   </tr>
  </tbody>
 </table>
 </dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>
<h2 id="Examples">Examples</h2>

<h3 id="Setting_repeat_for_a_single_mask">Setting repeat for a single mask</h3>

<h4 id="CSS">CSS</h4>

<pre class="brush: css; highlight[6] notranslate">#masked {
  width: 250px;
  height: 250px;
  background: blue linear-gradient(red, blue);
  mask-image: url(https://mdn.mozillademos.org/files/12676/star.svg);
  mask-repeat: repeat; /* Can be changed in the live sample */
  margin-bottom: 10px;
}
</pre>

<div class="hidden">
<h4 id="HTML_Content">HTML Content</h4>

<pre class="brush: html notranslate">&lt;div id="masked"&gt;
&lt;/div&gt;
&lt;select id="repetition"&gt;
  &lt;option value="repeat-x"&gt;repeat-x&lt;/option&gt;
  &lt;option value="repeat-y"&gt;repeat-y&lt;/option&gt;
  &lt;option value="repeat" selected&gt;repeat&lt;/option&gt;
  &lt;option value="space"&gt;space&lt;/option&gt;
  &lt;option value="round"&gt;round&lt;/option&gt;
  &lt;option value="no-repeat"&gt;no-repeat&lt;/option&gt;
&lt;/select&gt;
</pre>

<h4 id="JavaScript_Content">JavaScript Content</h4>

<pre class="brush: js notranslate">var repetition = document.getElementById("repetition");
repetition.addEventListener("change", function (evt) {
  document.getElementById("masked").style.maskRepeat = evt.target.value;
});
</pre>
</div>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Setting_repeat_for_a_single_mask", "290px", "290px")}}</p>

<h3 id="Multiple_mask_image_support">Multiple mask image support</h3>

<p>You can specify a different <code>&lt;repeat-style&gt;</code> for each mask image, separated by commas:</p>

<pre class="brush: css notranslate">.examplethree {
  mask-image: url('mask1.png'), url('mask2.png');
  mask-repeat: repeat-x, repeat-y;
}
</pre>

<p>Each image is matched with the corresponding repeat style, from first specified to last.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS Masks", "#the-mask-repeat", "mask-repeat")}}</td>
   <td>{{Spec2("CSS Masks")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.mask-repeat")}}</p>

<h2 id="See_also">See also</h2>

<ul>
  <li><a href="https://css-tricks.com/clipping-masking-css/">Clipping and Masking in CSS</a></li>
</ul>
